package ua.in.hutorny.fsa.util;

import java.util.Set;

import ua.in.hutorny.fsa.model.State;

public abstract class Traverser<T> {
	public Traverser(Class<? extends T> state, Class<? extends T> clazz, Set<Class<? extends T>> visited) {
		super();
		assert state != null;
		assert clazz != null;
		assert visited != null;
		this.clazz = clazz;
		this.visited = visited;
		this.state = state;
	}
	
    public abstract void visit(Class<? extends T> clazz);
    
    @SuppressWarnings("unchecked")
	public void traverse() {
		Class<?> superc = clazz.getSuperclass();		
		if( null != superc && state.isAssignableFrom(superc) && ! visited.contains(superc)) {
			visit((Class<? extends T>) superc);
			visited.add((Class<? extends T>) superc);
		}
		for(Class<?> superi : clazz.getInterfaces()) {
			if( State.class.isAssignableFrom(superi) && ! visited.contains(superi) ) {
				visit((Class<? extends T>) superi);
				visited.add((Class<? extends T>) superi);
			}
		}	  
    }
	private final Class<? extends T> clazz; 
	private final Class<? extends T> state; 
	private final Set<Class<? extends T>> visited;
}
